/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 * 
 * This file is part of de.bsvrz.pua.prot.
 * 
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bsvrz.pua.prot.client.console;

import de.bsvrz.pua.prot.Protocols;
import de.bsvrz.sys.funclib.losb.util.cmdinterface.Command;

/**
 * Kommando zum Herunterfahren der SWE 'Protokolle und Auswertungen'.
 *
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $Revision$ / $Date$ / ($Author$)
 */
public class ShutdownCommand extends Command {

	private final Protocols _protocols;

	/**
	 * Initialisierung.
	 *
	 * @param protocols Hauptklasse.
	 */
	public ShutdownCommand(Protocols protocols) {
		super("Herunterfahren", "Fährt die Softwareeinheit Protokolle und Auswertungen herunter. Alle Aufträge werden abgebrochen.");
		this._protocols = protocols;
	}

	/** @see de.bsvrz.sys.funclib.losb.util.cmdinterface.Command#execute() */
	@Override
	public void execute() throws Exception {
		this.println("Pua wird heruntergefahren. \nEs werden alle laufenden Anfragen abgebrochen. \nSind Sie sicher.? [j|n]");
		String input = this.readln();
		if(input.equalsIgnoreCase("j")) {
			this.println("Fahre System herunter.");
			_protocols.exit(null);
		}
	}
}
