
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "status",
    "betriebsmeldungen",
    "davconnection"
})
public class StartStoppStatus implements Serializable
{

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    @JsonPropertyDescription("der Status der StartStoppApplikation")
    private StartStoppStatus.Status status = StartStoppStatus.Status.fromValue("initialized");
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("betriebsmeldungen")
    private Boolean betriebsmeldungen = true;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("davconnection")
    private Boolean davconnection = false;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 3885227794293460381L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppStatus() {
    }

    /**
     * 
     * @param davconnection
     * @param betriebsmeldungen
     * @param status
     */
    public StartStoppStatus(StartStoppStatus.Status status, Boolean betriebsmeldungen, Boolean davconnection) {
        super();
        this.status = status;
        this.betriebsmeldungen = betriebsmeldungen;
        this.davconnection = davconnection;
    }

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    public StartStoppStatus.Status getStatus() {
        return status;
    }

    /**
     * der Status der StartStoppApplikation
     * (Required)
     * 
     */
    @JsonProperty("status")
    public void setStatus(StartStoppStatus.Status status) {
        this.status = status;
    }

    public StartStoppStatus withStatus(StartStoppStatus.Status status) {
        this.status = status;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("betriebsmeldungen")
    public Boolean getBetriebsmeldungen() {
        return betriebsmeldungen;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("betriebsmeldungen")
    public void setBetriebsmeldungen(Boolean betriebsmeldungen) {
        this.betriebsmeldungen = betriebsmeldungen;
    }

    public StartStoppStatus withBetriebsmeldungen(Boolean betriebsmeldungen) {
        this.betriebsmeldungen = betriebsmeldungen;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("davconnection")
    public Boolean getDavconnection() {
        return davconnection;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("davconnection")
    public void setDavconnection(Boolean davconnection) {
        this.davconnection = davconnection;
    }

    public StartStoppStatus withDavconnection(Boolean davconnection) {
        this.davconnection = davconnection;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppStatus withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("status", status).append("betriebsmeldungen", betriebsmeldungen).append("davconnection", davconnection).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(davconnection).append(additionalProperties).append(betriebsmeldungen).append(status).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppStatus) == false) {
            return false;
        }
        StartStoppStatus rhs = ((StartStoppStatus) other);
        return new EqualsBuilder().append(davconnection, rhs.davconnection).append(additionalProperties, rhs.additionalProperties).append(betriebsmeldungen, rhs.betriebsmeldungen).append(status, rhs.status).isEquals();
    }

    public enum Status {

        INITIALIZED("initialized"),
        RUNNING("running"),
        RUNNING_CANCELED("running_canceled"),
        STOPPING("stopping"),
        STOPPING_CANCELED("stopping_canceled"),
        STOPPED("stopped"),
        SHUTDOWN("shutdown"),
        CONFIGERROR("configerror");
        private final String value;
        private final static Map<String, StartStoppStatus.Status> CONSTANTS = new HashMap<String, StartStoppStatus.Status>();

        static {
            for (StartStoppStatus.Status c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Status(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static StartStoppStatus.Status fromValue(String value) {
            StartStoppStatus.Status constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
