
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "name",
    "version",
    "erstelltDurch",
    "aenderungsGrund",
    "pruefsumme"
})
public class StartStoppVersion implements Serializable
{

    @JsonProperty("name")
    private String name;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    private String version;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    private String erstelltDurch;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    private String aenderungsGrund;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    private String pruefsumme;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -3322589056044177778L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppVersion() {
    }

    /**
     * 
     * @param name
     * @param pruefsumme
     * @param version
     * @param aenderungsGrund
     * @param erstelltDurch
     */
    public StartStoppVersion(String name, String version, String erstelltDurch, String aenderungsGrund, String pruefsumme) {
        super();
        this.name = name;
        this.version = version;
        this.erstelltDurch = erstelltDurch;
        this.aenderungsGrund = aenderungsGrund;
        this.pruefsumme = pruefsumme;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public StartStoppVersion withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    public String getVersion() {
        return version;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    public void setVersion(String version) {
        this.version = version;
    }

    public StartStoppVersion withVersion(String version) {
        this.version = version;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    public String getErstelltDurch() {
        return erstelltDurch;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    public void setErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
    }

    public StartStoppVersion withErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    public String getAenderungsGrund() {
        return aenderungsGrund;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    public void setAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
    }

    public StartStoppVersion withAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    public String getPruefsumme() {
        return pruefsumme;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    public void setPruefsumme(String pruefsumme) {
        this.pruefsumme = pruefsumme;
    }

    public StartStoppVersion withPruefsumme(String pruefsumme) {
        this.pruefsumme = pruefsumme;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppVersion withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("name", name).append("version", version).append("erstelltDurch", erstelltDurch).append("aenderungsGrund", aenderungsGrund).append("pruefsumme", pruefsumme).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(name).append(additionalProperties).append(pruefsumme).append(version).append(aenderungsGrund).append(erstelltDurch).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppVersion) == false) {
            return false;
        }
        StartStoppVersion rhs = ((StartStoppVersion) other);
        return new EqualsBuilder().append(name, rhs.name).append(additionalProperties, rhs.additionalProperties).append(pruefsumme, rhs.pruefsumme).append(version, rhs.version).append(aenderungsGrund, rhs.aenderungsGrund).append(erstelltDurch, rhs.erstelltDurch).isEquals();
    }

}
