
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "adresse",
    "passWord",
    "port",
    "userName"
})
public class ZugangDav implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("adresse")
    private String adresse = "localhost";
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passWord")
    private String passWord = "passwort";
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    private String port = "3000";
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("userName")
    private String userName = "Tester";
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -1784500240217579133L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public ZugangDav() {
    }

    /**
     * 
     * @param passWord
     * @param port
     * @param adresse
     * @param userName
     */
    public ZugangDav(String adresse, String passWord, String port, String userName) {
        super();
        this.adresse = adresse;
        this.passWord = passWord;
        this.port = port;
        this.userName = userName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("adresse")
    public String getAdresse() {
        return adresse;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("adresse")
    public void setAdresse(String adresse) {
        this.adresse = adresse;
    }

    public ZugangDav withAdresse(String adresse) {
        this.adresse = adresse;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passWord")
    public String getPassWord() {
        return passWord;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passWord")
    public void setPassWord(String passWord) {
        this.passWord = passWord;
    }

    public ZugangDav withPassWord(String passWord) {
        this.passWord = passWord;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    public String getPort() {
        return port;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    public void setPort(String port) {
        this.port = port;
    }

    public ZugangDav withPort(String port) {
        this.port = port;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("userName")
    public String getUserName() {
        return userName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("userName")
    public void setUserName(String userName) {
        this.userName = userName;
    }

    public ZugangDav withUserName(String userName) {
        this.userName = userName;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public ZugangDav withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("adresse", adresse).append("passWord", passWord).append("port", port).append("userName", userName).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(adresse).append(passWord).append(additionalProperties).append(userName).append(port).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof ZugangDav) == false) {
            return false;
        }
        ZugangDav rhs = ((ZugangDav) other);
        return new EqualsBuilder().append(adresse, rhs.adresse).append(passWord, rhs.passWord).append(additionalProperties, rhs.additionalProperties).append(userName, rhs.userName).append(port, rhs.port).isEquals();
    }

}
